"use strict";(globalThis.webpackChunk=globalThis.webpackChunk||[]).push([["app_gettingStartedDocs_php_laravel_tsx"],{"./app/gettingStartedDocs/php/laravel.tsx":(e,t,n)=>{n.r(t),n.d(t,{GettingStartedWithLaravel:()=>p,default:()=>u,steps:()=>d});var o=n("../node_modules/react/index.js"),i=n("./app/components/links/externalLink.tsx"),r=n("./app/components/onboarding/gettingStartedDoc/layout.tsx"),a=n("./app/components/onboarding/gettingStartedDoc/step.tsx"),s=n("./app/locale.tsx"),l=n("../node_modules/@emotion/react/jsx-runtime/dist/emotion-react-jsx-runtime.browser.esm.js");const c=(0,s._N)("This guide is for Laravel 8+. We also provide instructions for [otherVersionsLink:other versions] as well as [lumenSpecificLink:Lumen-specific instructions].",{otherVersionsLink:(0,l.tZ)(i.Z,{href:"https://docs.sentry.io/platforms/php/guides/laravel/other-versions/"}),lumenSpecificLink:(0,l.tZ)(i.Z,{href:"https://docs.sentry.io/platforms/php/guides/laravel/other-versions/lumen/"})}),d=function(){let{dsn:e}=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return[{type:a.WU.INSTALL,configurations:[{description:(0,l.tZ)("p",{children:(0,s._N)("Install the [code:sentry/sentry-laravel] package:",{code:(0,l.tZ)("code",{})})}),language:"bash",code:"composer require sentry/sentry-laravel"},{description:(0,l.tZ)("p",{children:(0,s._N)("Enable capturing unhandled exception to report to Sentry by making the following change to your [code:App/Exceptions/Handler.php]:",{code:(0,l.tZ)("code",{})})}),language:"php",code:"\npublic function register() {\n  $this->reportable(function (Throwable $e) {\n    if (app()->bound('sentry')) {\n      app('sentry')->captureException($e);\n    }\n  });\n}\n        "}],additionalInfo:(0,l.tZ)("p",{children:(0,s._N)("Alternatively, you can configure Sentry in your [laravelLogChannelLink:Laravel Log Channel], allowing you to log [code:info] and [code:debug] as well.",{code:(0,l.tZ)("code",{}),laravelLogChannelLink:(0,l.tZ)(i.Z,{href:"https://docs.sentry.io/platforms/php/guides/laravel/usage/#log-channels"})})})},{type:a.WU.CONFIGURE,configurations:[{description:(0,s.t)("Configure the Sentry DSN with this command:"),language:"shell",code:`php artisan sentry:publish --dsn=${e}`},{description:(0,l.tZ)("p",{children:(0,s._N)('It creates the config file ([code:config/sentry.php]) and adds the [code:DSN] to your ".env" file.',{code:(0,l.tZ)("code",{})})}),language:"shell",code:`php artisan sentry:publish --dsn=${e}`}]},{type:a.WU.VERIFY,configurations:[{description:(0,l.tZ)("h5",{children:(0,s.t)("Verify With Artisan")}),configurations:[{description:(0,l.tZ)("p",{children:(0,s._N)("You can test your configuration using the provided [code:sentry:test] artisan command:",{code:(0,l.tZ)("code",{})})}),language:"source-shell",code:"php artisan sentry:test"}]},{description:(0,l.tZ)("h5",{children:(0,s.t)("Verify With Code")}),configurations:[{description:(0,s.t)("You can verify that Sentry is capturing errors in your Laravel application by creating a route that will throw an exception:"),language:"php",code:"\nRoute::get('/debug-sentry', function () {\n    throw new Exception('My first Sentry error!');\n});\n            ",additionalInfo:(0,s.t)("Visiting this route will trigger an exception that will be captured by Sentry.")}]}]},{title:(0,s.t)("Performance Monitoring"),configurations:[{description:(0,l.tZ)("p",{children:(0,s._N)('Set [code:traces_sample_rate] in [code:config/sentry.php] or [code:SENTRY_TRACES_SAMPLE_RATE] in your ".env" to a value greater than "0.0". Setting a value greater than "0.0" will enable Performance Monitoring, "0" (the default) will disable Performance Monitoring.',{code:(0,l.tZ)("code",{})})}),language:"shell",code:"\n# Be sure to lower this value in production otherwise you could burn through your quota quickly.\nSENTRY_TRACES_SAMPLE_RATE=1.0\n        ",additionalInfo:(0,l.BX)(o.Fragment,{children:[(0,s.t)("The example configuration above will transmit 100% of captured traces. Be sure to lower this value in production or you could use up your quota quickly."),(0,l.tZ)("p",{children:(0,s._N)("You can also be more granular with the sample rate by using the traces_sampler option. Learn more in [usingSampleToFilterLink:Using Sampling to Filter Transaction Events].",{usingSampleToFilterLink:(0,l.tZ)(i.Z,{href:"https://docs.sentry.io/platforms/php/guides/laravel/configuration/filtering/#using-sampling-to-filter-transaction-events"})})}),(0,l.tZ)("p",{children:(0,s._N)("Performance data is transmitted using a new event type called 'transactions', which you can learn about in Distributed Tracing.",{distributedTracingLink:(0,l.tZ)(i.Z,{href:"https://docs.sentry.io/product/sentry-basics/tracing/distributed-tracing/#traces-transactions-and-spans"})})})]})}]},{title:(0,s.t)("Local Development and Testing"),description:(0,l.BX)(o.Fragment,{children:[(0,s.t)("When Sentry is installed in your application, it will also be active when you are developing or running tests."),(0,l.tZ)("p",{children:(0,s._N)("You most likely don't want errors to be sent to Sentry when you are developing or running tests. To avoid this, set the DSN value to [code:null] to disable sending errors to Sentry.",{code:(0,l.tZ)("code",{})})}),(0,l.tZ)("p",{children:(0,s._N)("You can also do this by not defining [code:SENTRY_LARAVEL_DSN] in your [code:.env] or by defining it as [code:SENTRY_LARAVEL_DSN=null].",{code:(0,l.tZ)("code",{})})}),(0,l.tZ)("p",{children:(0,s.t)("If you do leave Sentry enabled when developing or running tests, it's possible for it to have a negative effect on the performance of your application or test suite.")})]})}]};function p(e){let{dsn:t,...n}=e;return(0,l.tZ)(r.A,{steps:d({dsn:t}),introduction:c,...n})}p.displayName="GettingStartedWithLaravel";const u=p}}]);
//# sourceMappingURL=../sourcemaps/app_gettingStartedDocs_php_laravel_tsx.6a10969876fe4c34952a127be9741aef.js.map